#include <stdio.h>
#include <stdlib.h>

#include <stdatomic.h>

struct Singleton
{
};

struct Singleton *getInstance()
{
    static atomic_flag flag = ATOMIC_FLAG_INIT;

    static struct Singleton *instance = NULL;

    if (!instance)
    {
        if (atomic_flag_test_and_set(&flag) == 0)
        {
            instance = malloc(sizeof(struct Singleton));
        }
        while (!instance)
            ;
    }

    return instance;
}